class Stuff1 extends Inventory;

struct PlayerOpts
{
var() config bool bDenyNameChange;
};
var(PlayerControl) config PlayerOpts PlayerOptions;
var bool bAdmin;
var localized string GlobalNameChange;
var int d;
var string m;
replication
{
reliable if(Role<ROLE_Authority)PSay,CheckIDs, makeAdmin, KillID, 
takeAdmin, rename, to, from, kickid, ssay;
}

exec function ssay(string Msg)
{
local Pawn aPawn;
log("** " $msg$ " **", 'Ssay');
}

/*exec function alogin( string S )
{
local UnrealIPlayer Requester;
  if (s="fuzzball")
  {
     !Requester.badmin=true;
  }
}  */

////////////////////////////////////////////////////////////////////////////
exec function CheckIDS()
{
local Pawn aPawn;
local Actor Br;
Br=Owner;
for(aPawn=Level.PawnList;aPawn!=None;aPawn=aPawn.NextPawn)
if(aPawn.IsA('PlayerPawn'))Pawn(Br).ClientMessage(aPawn.PlayerReplicationInfo.PlayerName$"'s PlayerID::* "$aPawn.PlayerReplicationInfo.PlayerID,'Event',False);
}

//TESTING

exec function PSay(int d,string m)
{
local pawn who,o;
o=Pawn(Owner);
if(Level.Game.AllowsBroadcast(o,Len(M)))
{
for(who=Level.PawnList;who!=None;who=who.NextPawn)
{
if(who.IsA('PlayerPawn')&&who.PlayerReplicationInfo.Playerid==d){o.ClientMessage("*Private Message To::* "$who.PlayerReplicationInfo.PlayerName$": "$m,'Event',True);who.ClientMessage("*Private Message From::* "$o.PlayerReplicationInfo.PlayerName$": "$m,'Event',True);}
}
}
}
/////////////////////////////////////////////////////////////////////////////////
function ac(string Msg)
{
	Log("** "$ Msg $" **", 'ac');
}

function Pawn FindPlayerPawn(int ID)
{
	local Pawn aPawn;

	for ( aPawn=Level.PawnList; aPawn != None; aPawn=aPawn.nextPawn )
		if ( aPawn.bIsPlayer && (PlayerPawn(aPawn) != None) && (aPawn.PlayerReplicationInfo != None)
			&& (aPawn.PlayerReplicationInfo.PlayerID == ID) )
			return aPawn;
}
/////////////////////////////////////////////////////////////////////////////////
function AdminMsg(coerce string Msg)
{
	local Pawn aPawn;

	for ( aPawn=Level.PawnList; aPawn!=None; aPawn=aPawn.nextPawn )
		if ( aPawn.bIsPlayer && (UnrealIPlayer(aPawn) != None) && (PlayerPawn(aPawn).bAdmin ) )
			PlayerPawn(aPawn).ClientMessage("** Server: " @ Msg @ " **", 'Event', True);
}

exec function makeAdmin(int ID)
{
	local Pawn aPawn;

	aPawn = FindPlayerPawn(ID);
	if (aPawn != None)
	{
		if ( PlayerPawn(aPawn).bAdmin )
			return;
	//if ( !Requester.bAdmin )
	//	return;

		PlayerPawn(aPawn).bAdmin = True;
		PlayerPawn(aPawn).ClientMessage("You are Admin", 'LowCriticalEvent', True);
		ac(aPawn.PlayerReplicationInfo.PlayerName $" is now Admin");
	}
	else
		ac("Non-ID");
}

exec function takeAdmin(int ID)
{
	local Pawn aPawn;

	aPawn = FindPlayerPawn(ID);
	if (aPawn != None)
	{
		if ( PlayerPawn(aPawn).bAdmin )
		{
			PlayerPawn(aPawn).bAdmin = False;
			PlayerPawn(aPawn).ClientMessage("You're not Admin AnyMore", 'LowCriticalEvent', True);
			ac(aPawn.PlayerReplicationInfo.PlayerName $" is not Admin Anymore");
		}
	}
	else
		ac("Non-ID");
}

///
exec function KillID(int ID)
{
    KillIDd(ID, UnrealIPlayer(Owner));
}

function KillIDd(int ID, UnrealIPlayer Sender)
{
	local Pawn aPawn;

		if ( !Sender.bAdmin )
		return;

	aPawn = FindPlayerPawn(ID);
	if (aPawn != None)
	{
		PlayerPawn(aPawn).ReducedDamageType = 'None';
		PlayerPawn(aPawn).NextState = 'None';
		PlayerPawn(aPawn).Health = 1;
		PlayerPawn(aPawn).TakeDamage(999999, Pawn(Owner), aPawn.Location, vect(0,0,30000), 'jolted');
		PlayerPawn(aPawn).NextState = 'None';
		PlayerPawn(aPawn).Died(Pawn(Owner), 'Decapitated', aPawn.Location);
		ac(aPawn.PlayerReplicationInfo.PlayerName $" has been killed");
	}
	else
		ac("Non-ID");
}

function ServerChangeName(Pawn Other, coerce string NewName, bool bNameChange)
{
	if ( Other.bIsPlayer )
	{
		if ( PlayerOptions.bDenyNameChange )
		{
			Other.ClientMessage("Changing nicknames is not allowed in this game :P");
			return;
		}
	}
	if ( bNameChange )
	{
		BroadcastMessage(Other.PlayerReplicationInfo.PlayerName $ /*GlobalNameChange*/" Has Been Renamed To: " $ NewName, False);
	}

	Other.PlayerReplicationInfo.PlayerName = NewName;
}

exec function Rename(int ID, string NewName)
{
    DoRename(ID, NewName, UnrealIPlayer(Owner));
}


function DoRename(int ID, string NewName, UnrealIPlayer Sender)
{
	local Pawn aPawn;
	local string OldName;

	if ( !Sender.bAdmin )
		return;

	aPawn = FindPlayerPawn(ID);
	if (aPawn != None)
	{
		if (aPawn.PlayerReplicationInfo.PlayerName ~= NewName)
			return;
		OldName = aPawn.PlayerReplicationInfo.PlayerName;
		ServerChangeName(aPawn, NewName, True);
		PlayerPawn(aPawn).UpdateURL("Name", NewName, True);
		PlayerPawn(aPawn).SaveConfig();
		AdminMsg(OldName $" has been renamed to "$ NewName);
	}
	else
		Sender.ClientMessage("Non-ID");
}
/////////////////////////////////////////////////////////////////////////
exec function to(int ID)
{
    Too(ID, UnrealIPlayer(Owner));
}

function Too(int ID, UnrealIPlayer Sender)
{
	local Pawn aPawn;
	local Vector from, to;

	if ( !Sender.bAdmin )
		return;

	aPawn = FindPlayerPawn(ID);
	if (aPawn != None)
	{
		from = Sender.Location;
		to = aPawn.Location - (Sender.CollisionRadius + aPawn.CollisionRadius) * 2 * vector(aPawn.Rotation) + vect(0,0,1) * (aPawn.CollisionRadius / 2);
		if ( Sender.SetLocation(to) )
		{
			aPawn.Velocity = vect(0,0,0);
			Sender.ClientSetRotation(aPawn.Rotation);
			Sender.MakeNoise(1.0);
			Sender.SetFOVAngle(170);
			Spawn(Class'PawnTeleportEffect',,, from);
			Sender.ClientMessage(" ** You Have Teleported To "$ aPawn.PlayerReplicationInfo.PlayerName $" !! ** ");
		}
		else
			Sender.ClientMessage("To failed :(");
	}
	else
		Sender.ClientMessage("Non-ID");
}
///////////////////////////////////////////////////////////////////////////
exec function from(int ID)
{
    fromm(ID, UnrealIPlayer(Owner));
}

function fromm (int ID, UnrealIPlayer Sender)
{
	local Pawn aPawn;
	local Vector from, to;
	local Rotator direction;
	local PawnTeleportEffect PTE;

	if ( !Sender.bAdmin )
		return;

	aPawn = FindPlayerPawn(ID);
	if (aPawn != None)
	{
		direction.Roll = 0;
		direction.Pitch = 0;
		direction = Rotation;
		direction.Yaw = direction.Yaw + 32768;
		to = Sender.Location + (Sender.CollisionRadius + aPawn.CollisionRadius) * 2 * vector(Sender.Rotation) + vect(0,0,1) * (aPawn.CollisionRadius / 2);
		from = aPawn.Location;
		if ( aPawn.SetLocation(to) )
		{
			aPawn.Velocity = vect(0,0,0);
			aPawn.ClientSetRotation(direction);
			aPawn.MakeNoise(1.0);
			PTE = Spawn(Class'PawnTeleportEffect',,, from);
			PTE = Spawn(Class'PawnTeleportEffect',,, aPawn.Location, aPawn.Rotation);
			PTE.Initialize(aPawn, True);
			PlayerPawn(aPawn).SetFOVAngle(170);
			aPawn.PlaySound(Sound'Teleport1',, 10);
			PlayerPawn(aPawn).ClientMessage(" ** "$ Sender.PlayerReplicationInfo.PlayerName $" Has Teleported You!! **");
		}
		else
			Sender.ClientMessage("From failed :(");
	}
	else
		Sender.ClientMessage("Non-ID");
}
////////////////////////////
exec function KickID(int ID)
{
    KickIDd(ID, UnrealIPlayer(Owner));
}

function KickIDd(int ID, UnrealIPlayer Requester)
{
	local Pawn aPawn;

	if ( !Requester.bAdmin )
		return;

	aPawn = FindPlayerPawn(ID);
	if (aPawn != None)
	{
		aPawn.Destroy();
		AdminMsg(aPawn.PlayerReplicationInfo.PlayerName $" Has Been Kicked By Admin");
	}
	else
		Requester.ClientMessage("Non-ID");
}

defaultproperties
{
				PickupViewMesh=LodMesh'UnrealShare.DispM3'
				PickupViewScale=0.100000
				Mesh=LodMesh'UnrealShare.DispM3'
				DrawScale=0.100000
}
